<?php
//AQL
include_once("/www/cgi-bin/inc/aql.php");
include_once("/www/cgi-bin/inc/function.inc");

function get_cdr_sw()
{
	$aql = new aql();
	$aql->set('basedir','/etc/asterisk');
	$hlock = lock_file('/etc/asterisk/gw.conf');
	$res = $aql->query("select * from gw.conf where section='cdr'");
	unlock_file($hlock);
	if(isset($res['cdr']['switch'])) {
		if(trim($res['cdr']['switch'])=='on') {
			return true;
		}
	}

	return false;
}

function get_sys_log_sw()
{
	$aql = new aql();
	$aql->set('basedir','/etc/asterisk');
	$hlock = lock_file('/etc/asterisk/gw.conf');
	$res = $aql->query("select * from gw.conf where section='sys-log'");
	unlock_file($hlock);
	if(isset($res['sys-log']['switch'])) {
		if(trim($res['sys-log']['switch'])=='on') {
			return true;
		}
	}

	return false;
}

function get_sip_log_sw()
{
	$aql = new aql();
	$aql->set('basedir','/etc/asterisk');
	$hlock = lock_file('/etc/asterisk/gw.conf');
	$res = $aql->query("select * from gw.conf where section='sip-log'");
	unlock_file($hlock);
	if(isset($res['sip-log']['switch'])) {
		if(trim($res['sip-log']['switch'])=='on') {
			return true;
		}
	}

	return false;
}

function get_debugat_log_sw()
{
	$aql = new aql();
	$aql->set('basedir','/etc/asterisk');
	$hlock = lock_file('/etc/asterisk/gw.conf');
	$res = $aql->query("select * from gw.conf where section='debugat-log'");
	unlock_file($hlock);
	if(isset($res['debugat-log']['switch'])) {
		if(trim($res['debugat-log']['switch'])=='on') {
			return true;
		}
	}

	return false;
}

function get_gsm_dialprefix($gsm_channel)
{
	if(!$gsm_channel)
		return '';

	$aql = new aql();
	$aql->set('basedir','/etc/asterisk');
	$hlock = lock_file('/etc/asterisk/gw_gsm.conf');
	$res = $aql->query("select * from gw_gsm.conf where section=\"$gsm_channel\"");
	unlock_file($hlock);
	if(isset($res[$gsm_channel]['dialprefix'])) {
		return trim($res[$gsm_channel]['dialprefix']);
	}

	return '';
}

function get_smssender_option()
{
	$ret = array();
	$aql = new aql();
	$aql->set('basedir','/etc/asterisk/gw');
	$hlock = lock_file('/etc/asterisk/gw/sms.conf');
	$val = $aql->query("select * from sms.conf where section='send'");
	unlock_file($hlock);
	if(isset($val['send']['attempt'])) {
		$ret['attempt'] = trim($val['send']['attempt']);
	}

	if(isset($val['send']['repeat'])) {
		$ret['repeat'] = trim($val['send']['repeat']);
	}

	if(isset($val['send']['verbose'])) {
		$ret['verbose'] = trim($val['send']['verbose']);
	}

	return $ret;
}


function get_sip_username($endpoint_name)
{
/* /etc/asterisk/gw_endpoints.conf */
// [endpoint_name]
// username = 
// registration =  
// register =    like sip.conf [general]
// .......       like all sip.conf

	$aql = new aql();
	$aql->set('basedir','/etc/asterisk');
	$hlock = lock_file('/etc/asterisk/gw_endpoints.conf');
	$res = $aql->query("select * from gw_endpoints.conf where section='$endpoint_name'");
	unlock_file($hlock);

	if(isset($res[$endpoint_name]['username'])) {
		return trim($res[$endpoint_name]['username']);
	}

	return '';
}

function get_sip_username_and_ip($endpoint_name)
{
/* /etc/asterisk/gw_endpoints.conf */
// [endpoint_name]
// username = 
// registration =  
// register =    like sip.conf [general]
// .......       like all sip.conf

	$aql = new aql();
	$aql->set('basedir','/etc/asterisk');
	$hlock = lock_file('/etc/asterisk/gw_endpoints.conf');
	$res = $aql->query("select * from gw_endpoints.conf where section='$endpoint_name'");
	unlock_file($hlock);

	if(isset($res[$endpoint_name]['username'])) {
		$username = trim($res[$endpoint_name]['username']);

		if(isset($res[$endpoint_name]['host'])) {
			$ip = trim($res[$endpoint_name]['host']);
			if($ip != '' && $ip != 'dynamic')
				return $username.'-'.$ip;

			return $username;
		} else {
			return $username;
		}
	}

	return '';
}

function get_sip_registration($endpoint_name)
{
/* /etc/asterisk/gw_endpoints.conf */
// [endpoint_name]
// username = 
// registration =  
// register =    like sip.conf [general]
// .......       like all sip.conf

	$aql = new aql();
	$aql->set('basedir','/etc/asterisk');
	$hlock = lock_file('/etc/asterisk/gw_endpoints.conf');
	$res = $aql->query("select * from gw_endpoints.conf where section='$endpoint_name'");
	unlock_file($hlock);

	if(isset($res[$endpoint_name]['registration'])) {
		return trim($res[$endpoint_name]['registration']);
	}

	return '';
}

function get_channel_info($type_and_name)
{
	$info['type'] = '';
	$info['name'] = '';
	$info['device'] = '';
	$info['context'] = '';
	$info['registration'] = '';    //GSM not has this.
	$info['channel'] = '';         //SIP not has this.

	global $__GSM_HEAD__;
	global $__SIP_HEAD__;

	if(substr($type_and_name,0,strlen($__SIP_HEAD__)) == $__SIP_HEAD__) { //SIP
		$name = substr($type_and_name,strlen($__SIP_HEAD__));
		$sip_username_and_ip = get_sip_username_and_ip($name);
		$registration = get_sip_registration($name);
		if($sip_username_and_ip == '') {
			$context = '';
			$device = '';
		} else {
			$context = $__SIP_HEAD__.$sip_username_and_ip;
			$device = "SIP/$sip_username_and_ip";
		}

		$info['type'] = 'sip';
		$info['name'] = $name;
		$info['context'] = $context;
		$info['device'] = $device;
		$info['registration'] = $registration;
	} else if(substr($type_and_name,0,strlen($__GSM_HEAD__)) == $__GSM_HEAD__) { //GSM
		$name = substr($type_and_name,strlen($__GSM_HEAD__));
		if($name == '') {
			$context = '';
			$device = '';
		} else {
			$info['channel'] = $name;
			$voice_channel = $name*2-1;
			$context = $__GSM_HEAD__.$name;
			if(($gsmname = get_gsmname($name)) != '') {
				$name = $__GSM_HEAD__."$name($gsmname)";
			} else {
				$name = $__GSM_HEAD__.$name;
			}
			$device = "extra/$voice_channel";
		}

		$info['type'] = 'gsm';
		$info['name'] = $name;
		$info['context'] = $context;
		$info['device'] = $device;
	}

	return $info;
}

function get_internal_sip_call()
{
	$aql = new aql();
	$aql->set('basedir','/etc/asterisk');
	$hlock = lock_file('/etc/asterisk/sip_general.conf');
	$sip_general = $aql->query("select * from sip_general.conf");
	unlock_file($hlock);
	if( isset($sip_general['general']['enable_internal_sip_call']) &&
		isset($sip_general['general']['internal_sip_call_prefix'])
	) {
		if($sip_general['general']['enable_internal_sip_call'] == 'yes' ) {
			$ret['prefix'] = trim($sip_general['general']['internal_sip_call_prefix']);
			return $ret;
		}
	}
		
	return false;	
}
function get_cdrs($file,$sort = false,$sl,$count)
{
	$statics = array();
	$aql = new aql();
	$filepath="/www/config/".$file;
	$aql->set('basedir','/www/config');
	$hlock = lock_file($filepath);
	$statics = $aql->query("select * from $file limit $sl,$count");
	unlock_file($hlock);
	return $statics;
}
function get_cdrs_filter($file,$case,$sort = false,$sl,$count)
{
	$statics = array();
	$aql = new aql();
	$filepath="/www/config/".$file;
	$aql->set('basedir','/www/config');
	$hlock = lock_file($filepath);
	$statics = $aql->query_filter("select * from $file $case limit $sl,$count");
	unlock_file($hlock);
	return $statics;
}
function get_statics($file,$sort = false)
{
	$statics = array();
	$aql = new aql();
	$filepath="/www/config/".$file;
	$aql->set('basedir','/www/config');
	$hlock = lock_file($filepath);
	$statics = $aql->query("select * from $file");
	unlock_file($hlock);
	return $statics;
}
function get_all_chans($sort = false)
{
	$skypes = array();
	$aql = new aql();
	$aql->set('basedir','/www/config');
	$hlock = lock_file('/www/config/channelsstate.conf');
	$skypes = $aql->query("select * from channelsstate.conf");
	unlock_file($hlock);
	return $skypes;
}
function get_user($sort = false)
{
	$skypes = array();
	$aql = new aql();
	$aql->set('basedir','/www/config');
	$hlock = lock_file('/www/config/user.conf');
	$skypes = $aql->query("select * from user.conf");
	unlock_file($hlock);
	return $skypes;
}
function get_gwconfig($sort = false)
{
	$skypes = array();
	$aql = new aql();
	$aql->set('basedir','/www/config');
	$hlock = lock_file('/www/config/gw.conf');
	$skypes = $aql->query("select * from gw.conf");
	unlock_file($hlock);
	return $skypes;
}
function get_all_skypes($sort = false)
{
	$skypes = array();
	$aql = new aql();
	$aql->set('basedir','/www/config');
	$hlock = lock_file('/www/config/skypes.conf');
	$skypes = $aql->query("select * from skypes.conf");
	unlock_file($hlock);
	return $skypes;
}
function get_all_auths($sort = false)
{
	$skypes = array();
	$aql = new aql();
	$aql->set('basedir','/www/config');
	$hlock = lock_file('/www/config/auths.conf');
	$skypes = $aql->query("select * from auths.conf");
	unlock_file($hlock);
	return $skypes;
}
function get_all_sips($sort = false)
{
/* /etc/asterisk/gw_endpoints.conf */
// [endpoint_name]
// order = 1,2,3,4,5....    //Must set
// username = 
// registration =  
// register =    like sip.conf [general]
// .......       like all sip.conf

	$sips = array();
	$aql = new aql();
	$aql->set('basedir','/www/config');
	$hlock = lock_file('/www/config/sip.conf');
	$sips = $aql->query("select * from sip.conf");
	unlock_file($hlock);
	return $sips;
}
function get_all_groups($sort = false)
{
	// /etc/init.d/gw_routing.conf
	// [routing_name]
	// order = 1,2,3,4,5....    //Must set
	// from_channel = channel (sip-sipname or gsm-gsmname  type: sip- is SIP, gsm- is GSM)
	// to_channel = channel,channel......
	// begin_digit
	// digit_len_start
	// digit_len_end
	// trim_digit
	// prepend_digit
	// cid_name
	// cid_number

	$groups = array();
	$aql = new aql();
	$aql->set('basedir','/www/config');
	$hlock = lock_file('/www/config/skype_groups.conf');
	$groups = $aql->query("select * from skype_groups.conf");
	unlock_file($hlock);
	return $groups;
}

function get_all_routings($sort = false)
{
	// /etc/init.d/gw_routing.conf
	// [routing_name]
	// order = 1,2,3,4,5....    //Must set
	// from_channel = channel (sip-sipname or gsm-gsmname  type: sip- is SIP, gsm- is GSM)
	// to_channel = channel,channel......
	// begin_digit
	// digit_len_start
	// digit_len_end
	// trim_digit
	// prepend_digit
	// cid_name
	// cid_number

	$routings = array();
	$aql = new aql();
	$aql->set('basedir','/www/config');
	$hlock = lock_file('/www/config/routing.conf');
	$routings = $aql->query("select * from routing.conf");
	unlock_file($hlock);

	if($routings) {
		foreach($routings as $key=>$value) {
			if(!isset($value['from_channel']) || (trim($value['from_channel']) == '')) {
				unset($routings[$key]);
				continue;
			} 

			if(!isset($value['to_channel']) || (trim($value['to_channel']) == '')) {
				unset($routings[$key]);
				continue;
			}

			if(!isset($value['order']) || (trim($value['order']) == '')) {
				unset($routings[$key]);
				continue;
			}

			$routings[$key]['routing_name'] = trim($key);    //Must save key, because call array_multisort then will change key name. Freedom Note 2012-11-27

			if($sort) {
				$ary2[$key]  = $value['order'];
			}
		}

		if(isset($ary2)) {
			array_multisort($ary2,SORT_ASC,$routings);  //It will be change key if your set key is numbers. Freedom Note 2012-11-27
		}
	}

	return $routings;
}

function is0to9($str)
{
	if(preg_match('/^[0-9]+$/',$str)) {
		return true;
	}
	return false;
}

function save_routings_to_extensions()
{
	// /etc/init.d/gw_routing.conf
	// [routing_name]
	// order = 1,2,3,4,5....    //Must set
	// from_channel = channel (sip-sipname or gsm-gsmname  type: sip- is SIP, gsm- is GSM)
	// to_channel = channel,channel......
	// dial_pattern = prepend|prefix|match pattern|cid,prepend|prefix|match pattern|cid........
	// cid_name
	// cid_number
	// forward_number

	global $__SIP_HEAD__;
	global $__GSM_HEAD__;
	global $__RTG_HEAD__;
	global $__GSM_SUM__;

	$MAX_PREFIX = 32;

	$write_array = array();

	$all_routings = get_all_routings(true);
	if($all_routings) {
		foreach($all_routings as $routing) {
			$routing_name = trim($routing['routing_name']);
			$from_channel = trim($routing['from_channel']);
			$from_channel_info = get_channel_info($from_channel);
			$to_channel = trim($routing['to_channel']);

			//Parse dial_pattern
			/////////////////////////////////////////////////////
			if(isset($routing['dial_pattern'])){
				$val = trim($routing['dial_pattern']);
				$dp = explode(',',$val);
				if(is_array($dp) && isset($dp[0]) && $dp[0]) {
					$i = 0;
					foreach($dp as $each) {
						$tmp = explode('|',$each);
						if(isset($tmp[0])) {
							$dial_pattern[$i]['prepend'] = trim($tmp[0]);
						} else {
							$dial_pattern[$i]['prepend'] = '';
						}
						if(isset($tmp[1])) {
							$dial_pattern[$i]['prefix'] = trim($tmp[1]);
						} else {
							$dial_pattern[$i]['prefix'] = '';
						}
						if(isset($tmp[2])) {
							$dial_pattern[$i]['pattern'] = trim($tmp[2]);
						} else {
							$dial_pattern[$i]['pattern'] = '';
						}
						if(isset($tmp[3])) {
							$dial_pattern[$i]['cid'] = trim($tmp[3]);
						} else {
							$dial_pattern[$i]['cid'] = '';
						}
						$i++;
					}
				}
			}
			/////////////////////////////////////////////////////

			if(isset($routing['cid_name']))
				$cid_name = trim($routing['cid_name']);
			else
				$cid_name = '';

			if(isset($routing['cid_number']))
				$cid_number = trim($routing['cid_number']);
			else
				$cid_number = '';

			if(isset($routing['forward_number']))
				$forward_number = trim($routing['forward_number']);
			else
				$forward_number = '';

			// [$__RTG_HEAD__ routing_name] context
			////////////////////////////////////////////////////////////////////
			$devices = '';
			$to_channels = explode(',',$to_channel);
			if($to_channels) {
				foreach($to_channels as $each) {
					$channel = trim($each);
					$info = get_channel_info($channel);
					$cdr_name = $info['name'];
					$device = $info['device'];

					if($info['type'] == 'gsm') {
						$gsm_dialprefix = get_gsm_dialprefix($info['channel']);
					} else {
						$gsm_dialprefix = '';
					}

					if($device && $cdr_name) {

						//s:server, c:client, t:trunk.
						if($from_channel_info['type'] == 'sip') {
							if($info['type'] == 'sip') {
								if($info['registration'] == 'server') {  
									$devices .= "$device,1,$cdr_name,$gsm_dialprefix,";      // SIP(s,c,t) ---> SIP(s)   Not need transmit exten number
								} else {
									$devices .= "$device,0,$cdr_name,$gsm_dialprefix,";      // SIP(s,c,t) ---> SIP(c,t) Transmit exten number
								}
							} else {
								$devices .= "$device,0,$cdr_name,$gsm_dialprefix,";          // SIP(s,c,t) ---> GSM      Transmit exten number
							}
						} else {
							if($info['type'] == 'sip') {
								if($info['registration'] == 'server') {  
									$devices .= "$device,1,$cdr_name,$gsm_dialprefix,";      // GSM ---> SIP(s)          Not need transmit exten number
								} else {
									$devices .= "$device,1,$cdr_name,$gsm_dialprefix,";      // GSM ---> SIP(c,t)        Not need transmit exten number
								}
							} else {
								$devices .= "$device,1,$cdr_name,$gsm_dialprefix,";          // GSM ---> GSM             Not need transmit exten number
							}
						}
					}
				}
				$devices = rtrim($devices,',');
			}

			if(isset($dial_pattern)) {
				if($from_channel_info['type'] == 'gsm') {
					$exten['s']['e'] = 's';
					$exten['s']['d'] = '';
				} else {
					$i = 0;
					foreach($dial_pattern as $each) {
						$prepend = '';
						if(isset($each['prepend'])) {
							$prepend = $each['prepend'];
						}
						$prefix = '';
						if(isset($each['prefix'])) {
							$prefix = $each['prefix'];
						}
						$pattern = '';
						if(isset($each['pattern'])) {
							$pattern = $each['pattern'];
						}
						$cid = '';
						if(isset($each['cid'])) {
							$cid = $each['cid'];
						}

						if($prefix == '') {
							if($pattern == '') {
								$exten[$i]['e'] = '_X.';
							} else {
								if(is0to9($pattern)) {
									$exten[$i]['e'] = "$pattern";
								} else {
									$exten[$i]['e'] = "_$pattern";
								}
							}
						} else {
							if($pattern == '') {
								if(is0to9($prefix)) {
									$exten[$i]['e'] = "$prefix";
								} else {
									$exten[$i]['e'] = "_$prefix";
								}
							} else {
								if(is0to9($prefix) && is0to9($pattern)) {
									$exten[$i]['e'] = "$prefix$pattern";
								} else {
									$exten[$i]['e'] = "_$prefix$pattern";
								}
							}
						}

						if($cid != '') {
							if(is0to9($cid)) {
								$exten[$i]['e'] .= "/$cid"; 
							} else {
								$exten[$i]['e'] .= "/_$cid";
							}
						}

						$strip = strlen($prefix);

						if($prepend == '') {
							if($strip > 0) {
								$exten[$i]['d'] = "\${EXTEN:$strip}";
							} else {
								$exten[$i]['d'] = "\${EXTEN}";
							}
						} else {
							if(is0to9($prepend)){
								if($strip > 0) {
									$exten[$i]['d'] = "$prepend\${EXTEN:$strip}";
								} else {
									$exten[$i]['d'] = "$prepend\${EXTEN}";
								}
							} else {
								if($strip > 0) {
									$exten[$i]['d'] = "_$prepend\${EXTEN:$strip}";
								} else {
									$exten[$i]['d'] = "_$prepend\${EXTEN}";
								}
							}
						}
					
						$i++;
					}
				} 
				unset($dial_pattern);
			} else {
				if($from_channel_info['type'] == 'gsm') {
					$exten['s']['e'] = 's';
					$exten['s']['d'] = '';
				} else {
					$exten[0]['e'] = '_X.';
					$exten[0]['d'] = '${EXTEN}';
				}
			}

			$routing_name_section = '';
			foreach($exten as $each) {
				$routing_name_section .= "exten => $each[e],1,NoOp($each[e] matches Rule $routing_name)\n";
				$routing_name_section .= "exten => $each[e],n,Set(CDR_EXTEN=\${EXTEN})\n";

				//Set CID name and CID number
				//Must use temporay value to save CID name and CID number, If you need swap CID name and CID number.
				///////////////////////////////////////////////////////////////////////////////////////
				if($cid_name != '')
					$routing_name_section .= "exten => $each[e],n,Set(T_CID_NAME=$cid_name)\n";
				if($cid_number != '')
					$routing_name_section .= "exten => $each[e],n,Set(T_CID_NUM=$cid_number)\n";
				if($cid_name != '')
					$routing_name_section .= "exten => $each[e],n,Set(CALLERID(name)=\${T_CID_NAME})\n";
				if($cid_number != '')
					$routing_name_section .= "exten => $each[e],n,Set(CALLERID(number)=\${T_CID_NUM})\n";
				///////////////////////////////////////////////////////////////////////////////////////

				if($devices != '') {
					$routing_name_section .= "exten => $each[e],n,Macro(dial-failover,$forward_number,$each[d],$devices)\n";
				}
			}
			unset($exten);

			$write_array[$__RTG_HEAD__.$routing_name] = $routing_name_section;
			///////////////////////////////////////////////////////////////////////

			// [from_channel] context
			///////////////////////////////////////////////////////////////////////
			$channel_context = $from_channel_info['context'];
			if($channel_context) {
				$from_channel_section = "include => ".$__RTG_HEAD__."$routing_name\n";

				if(array_key_exists($channel_context,$write_array)) { // [from_channel] context already writed
					$write_array[$channel_context] .= $from_channel_section;
				} else {  //First write
					$write_array[$channel_context] = $from_channel_section;
				}
			}
			///////////////////////////////////////////////////////////////////////
		}
	}

	// Set All Channel context
	//////////////////////////////////////////////////////////////////////////////////
	// GSM
	for($i=1; $i<=$__GSM_SUM__; $i++) {
		$key = $__GSM_HEAD__.$i;
		if(!array_key_exists($key,$write_array)) {
			$write_array[$key] = '';
			$write_array[$key] .= "exten => s,1,NoOp(Nothing to do, Not setting out channel)\n";
			$write_array[$key] .= "exten => s,n,Hangup()\n";
		}
		$write_array[$key] .= "exten => h,1,System(/my_tools/process_cdr \"\${CDR(src)}\" \"\${CDR_CALLEEID}\" \"$__GSM_HEAD__$i\" \"\${CDR_TOCHAN}\" \"\${CDR(start)}\" \"\${CDR(billsec)}\" \"\${CDR(disposition)}\")\n";
		$write_array[$key] .= "exten => sms, 1, System(/my_tools/process_sms \"$i\" \"\${SMSSRC}\" \"\${SMSTIME}\" \"\${SMSTXT}\")\n";
		$write_array[$key] .= "exten => sms_send_ok, 1, System(touch /tmp/sms/S\${SMS_SEND_ID})\n";
		$write_array[$key] .= "exten => sms_send_failed, 1, System(touch /tmp/sms/F\${SMS_SEND_ID})\n\n";
	}

	// SIP
	$internal_sip_call = get_internal_sip_call();
	$allsips = get_all_sips();
	$write_array['nothingtodo'] = "exten => _X.,1,NoOp(Nothing to do, Not setting out channel)\n";
	$write_array['nothingtodo'] .= "exten => _X.,n,Set(CDR_EXTEN=\${EXTEN})\n";
	$write_array['nothingtodo'] .= "exten => _X.,n,Hangup()\n\n";

	if($allsips) {
		foreach($allsips as $sip) {
			if(isset($sip['context']) && $sip['context']) {
				$info = get_channel_info($__SIP_HEAD__.$sip['endpoint_name']);
				$key = $info['context'];
				if(!array_key_exists($key,$write_array)) {
					$write_array[$key] = "include => nothingtodo\n";
				}
				$cdr_from = $sip['endpoint_name'];
				$write_array[$key] .= "exten => h,1,System(/my_tools/process_cdr \"\${CDR_EXTEN}\" \"\${CDR_CALLEEID}\" \"$cdr_from\" \"\${CDR_TOCHAN}\" \"\${CDR(start)}\" \"\${CDR(billsec)}\" \"\${CDR(disposition)}\")\n";

				if($internal_sip_call) {
					if($sip['registration'] == 'server') {
						$write_array[$key] = "include => internalsip\n" . $write_array[$key];  //Must put on first line.
					}
				}
			}
		}
		if($internal_sip_call) {
			$prefix = $internal_sip_call['prefix'];
			$len = strlen($prefix);
			$each = '_'.$prefix.'X.';
			$num = '${EXTEN:'.$len."}";
			$write_array['internalsip'] = "exten => $each,1,NoOp(SIP Internal Call\n";
			$write_array['internalsip'] .= "exten => $each,n,Set(CDR_EXTEN=\${EXTEN})\n";
			$write_array['internalsip'] .= "exten => $each,n,Set(CDR_TOCHAN=$num)\n";
			$write_array['internalsip'] .= "exten => $each,n,Dial(SIP/$num)\n";
			$write_array['internalsip'] .= "exten => $each,n,Hangup()\n\n";
		}
	}
	//////////////////////////////////////////////////////////////////////////////////

	//Write to extensions_routing.conf
	//////////////////////////////////////////////////////////////////////////////////
	$gsm_already_context = array();
	$cfg_file = '/etc/asterisk/extensions_routing.conf';
	$hlock = lock_file($cfg_file);
	$handle = fopen($cfg_file,"w");
	if($write_array) {
		foreach($write_array as $key => $value) {
			$str = "[$key]\n" . $value."\n\n";
			fwrite($handle,$str);
		}
	}
	fclose($handle);
	unlock_file($hlock);
	//////////////////////////////////////////////////////////////////////////////////
}

function del_all_register()
{
	$sip_general_conf = "/etc/asterisk/sip_general.conf";

	if(!file_exists($sip_general_conf))
		return;

	$hlock = lock_file($sip_general_conf);
	$handle = fopen($sip_general_conf,"r");
	$start = false;

	$write_str = '';
	while (!feof($handle)) {
		$line = fgets($handle);

		if(!$start) {
			if(preg_match("/\s*\[\s*general\s*\]\s*/",$line)) {
				$start = true;
			}
		} else {
			if(preg_match("/\s*\[\s*.*\s*\]\s*/",$line)) {
				$start = false;
			}
		}

		if($start) {
			if(preg_match("/\s*register\s*=\s*.*/",$line)) {
				continue;
			}
		}

		$write_str .= $line;
	}
	fclose($handle);

	//Write
	if($write_str != '') {
		$handle = fopen($sip_general_conf,"w");
		fwrite($handle,$write_str);
		fclose($handle);
	}
	unlock_file($hlock);
}


function save_endpoints_to_sips()
{
/* /etc/asterisk/gw_endpoints.conf */
// [endpoint_name]
// order = 1,2,3,4,5....    //Must set
// username = 
// registration =  
// register =    like sip.conf [general]
// .......       like all sip.conf

	global $__SIP_HEAD__;
	del_all_register();
	$all_sips = get_all_sips();

	if($all_sips) {
		$write_str='';
		foreach($all_sips as $sip) {
			$username = $sip['username'];
			$context = $username;
				
			if(isset($sip['host'])) {
				$ip = trim($sip['host']);
				if($ip != '' && $ip != 'dynamic') {
					$context = $username.'-'.$ip;
				}
			}
			$write_str .= "[$context]\n";

			foreach($sip as $key=>$value) {
				if($key == 'allow') {
				    $allow = explode(',',$value);
					foreach($allow as $each) {
						if($each != '')
							$write_str .= "allow=$each\n";
					}
				} else if($key =='context') {
					$write_str .= "context=".$__SIP_HEAD__."$context\n"; 
				} else if($key == 'register') {
					$register[] = $value;
				} else if($key == 'order') {
					//Not do anythings
				} else if($key == 'registration') {
					//Not do anythings
				} else if($key == 'register_extension') {
				    //Not do anythings
				} else {
					$write_str .= "$key=$value\n";
				}
			}
			$write_str .= "\n";
		}

		$cfg_file = '/etc/asterisk/sip_endpoints.conf';
		$hlock = lock_file($cfg_file);
		$handle = fopen($cfg_file,"w");
		fwrite($handle, $write_str);
		fclose($handle);
		unlock_file($hlock);

		if(isset($register)) {

			$aql = new aql();
			$aql->set('basedir','/etc/asterisk');
			$hlock = lock_file('/etc/asterisk/sip_general.conf');
			$exist_general_section = $aql->query("select * from sip_general.conf");
			if(!isset($exist_general_section['general'])) {  // if not exist 'general' section
				$aql->assign_addsection('general','');
				$aql->save_config_file('sip_general.conf');
			}
			foreach($register as $each) {
				$aql->assign_append('general','register','>'.$each);
			}
			$aql->save_config_file('sip_general.conf');
			unlock_file($hlock);
		}
	}
}


function save_gsm_to_extra_conf()
{
	global $__GSM_SUM__;

	$aql = new aql();
	$aql->set('basedir','/etc/asterisk');
	$hlock = lock_file('/etc/asterisk/gw_gsm.conf');
	$res = $aql->query("select * from gw_gsm.conf");
	unlock_file($hlock);
	if (!$res) {
		echo $aql->get_error();
		return;
	}

	$write_str = '';

	if(get_debugat_log_sw()) {
		$debugat='on';
	} else {
		$debugat='off';
	}

	for($channel=1; $channel <= $__GSM_SUM__; $channel++) {
		if(isset($res[$channel]['vol'])) {
			$vol=trim($res[$channel]['vol']);
		} else {
			$vol='';
		}

		if(isset($res[$channel]['mic'])) {
			$mic=trim($res[$channel]['mic']);
		} else {
			$mic='';
		}

		if(isset($res[$channel]['rxgain'])) {
			$rxgain=trim($res[$channel]['rxgain']);
		} else {
			$rxgain='';
		}

		if(isset($res[$channel]['txgain'])) {
			$txgain=trim($res[$channel]['txgain']);
		} else {
			$txgain='';
		}

		$pin = '';
		if(isset($res[$channel]['needpin'])) {
			if(trim($res[$channel]['needpin']) == "true") {
				if(isset($res[$channel]['pin'])) {
					$pin=trim($res[$channel]['pin']);
				}
			}
		}

		$write_str .= "group=1\n";
		$write_str .= "context=gsm-$channel\n";
		$write_str .= "signalling = gsm\n";
		$write_str .= "vol=$vol\n";
		$write_str .= "mic=$mic\n";
		$write_str .= "rxgain=$rxgain\n";
		$write_str .= "txgain=$txgain\n";
		$write_str .= "debugat=$debugat\n";
		$write_str .= "smscodec=utf-8\n";
		if($pin)$write_str .= "pin=$pin\n";
		$write_str .= "switchtype=SIMCOM_SIM840W\n";
		$tmp = $channel*2 -1;
		$write_str .= "channel => $tmp\n\n";
	}

	$extra_conf = '/etc/asterisk/extra-channels.conf';
	$hlock = lock_file($extra_conf);
	$handle = fopen($extra_conf,"w");
	fwrite($handle, $write_str);
	fclose($handle);
	unlock_file($hlock);
}

?>
