// Check valid ip addres or network address
function check_domain(str)
{
	var rex=/^(([a-z0-9](w|-){0,61}?[a-z0-9]|[a-z0-9]).){1,}(aero|arpa|asia|biz|cat|com|coop|co|edu|gov|info|int|jobs|mil|mobi|museum|name|net|org|pro|tel|travel|[a-z][a-z])(.[a-z][a-z]){0,1}$/i;

	if(rex.test(str)) {
		return false;
	}

	rex=/^((2[0-4][0-9]|25[0-5]|[01]?[0-9][0-9]?)\.){3}(2[0-4][0-9]|25[0-5]|[01]?[0-9][0-9]?)$/i;
	if(rex.test(str)) {
		return false;
	}

	return 'Invalid domain or IP address.';
}

// Check valid name (DIY)
// -_+.0-9a-zA-Z>, 32 character long
function check_diyname(str)
{
	var rex=/^[-_+.<>&0-9a-zA-Z]{1,32}$/i;

	if(rex.test(str)) {
		return false;
	}

	return 'Allowed character must be any of [-_+.<>&0-9a-zA-Z],1 - 32 characters.';
}
function check_num(str)
{
	var rex=/^[0-9]{1,32}$/i;

	if(rex.test(str)) {
		return false;
	}

	return 'Please input a valid number!';
}
function check_num2(str)
{
	var rex=/^[0-9]{0,32}$/i;

	if(rex.test(str)) {
		return false;
	}

	return 'Please input a valid number!';
}
function check_diypwd(str)
{
	var rex=/^[-_+.<>&0-9a-zA-Z]{4,32}$/i;

	if(rex.test(str)) {
		return false;
	}

	return 'Allowed character must be any of [-_+.<>&0-9a-zA-Z],4 - 32 characters.';

}


// Check valid GSM speacker volume level
function check_gsmvol(str)
{
	if(str >= 0 && str <= 100) {
		return false;
	}

	return ' Volume range: 0-100.';
}

// Check valid GSM microphone gain level
function check_gsmmic(str)
{
	if(str >= 0 && str <= 15) {
		return false;
	}

	return ' Volume range: 0-15.';
}

// Check valid GSM Gain
function check_gsmgain(str)
{
	if(str >= -100.0 && str <= +100.0) {
		return false;
	}

	return ' Gain range:  -100.0 - +100.0.';
}

function check_gsmrxgain(str)
{
	return check_gsmgain(str);
}

function check_gsmtxgain(str)
{
	return check_gsmgain(str);
}

function check_dialprefix(str)
{
	var rex=/^[0-9+]{0,10}$/i;
	if(rex.test(str)) {
		return false;
	}

	return 'Must be 0-9 or \'+\'';
}

// Check valid PIN of SIM card
function check_gsmpin(str)
{
	var rex=/^[0-9]{4}$/i;
	if(rex.test(str)) {
		return false;
	}

	return 'Must be 4 digits';
}

// Check valid email address
function check_email(str)
{
	var rex=/^([.a-zA-Z0-9_-])+@([a-zA-Z0-9_-])+((\.[a-zA-Z0-9_-]{2,3}){1,2})$/;

	if(rex.test(str)) {
		return false;
	}

	return 'Please input a valid email address';
}

function check_sipname(str)
{
	var rex=/^[0-9a-zA-Z]{1,32}$/;

	if(rex.test(str)) {
		return false;
	}

	return 'Only allow digits and english characters, length: 1-32';
}

// Check valid network port
function check_networkport(str)
{
	if(str >= 1 && str <= 65535) {
		return false;
	}

	return 'Please input valid port number (1-65535)';
}

// Check valid smtp user
function check_smtpuser(str)
{
	var rex=/^[\w@.]{1,64}$/i;
	if(rex.test(str)) {
		return false;
	}

	return 'Please input a valid STMP user name';
}

// Check valid smtp password
function check_smtppwd(str)
{
	var rex=/^[\w@.`~!#$%^&*()+=\-\{\}\\\|:;\'"<>,.\?]{1,64}$/i;
	if(rex.test(str)) {
		return false;
	}

	return 'Password character range: 1-64';
}

function check_ntpserver(str)
{
	return check_domain(str);
}

function check_phonenum(str)
{
	var rex=/^[0-9\+]{1,32}$/i;
	if(rex.test(str)) {
		return false;
	}

	return 'Please input a valid phone number!';
}

function check_ussd(str)
{
	var rex=/^[0-9\+\*\#]{1,32}$/i;
	if(rex.test(str)) {
		return false;
	}

	return 'Please input a valid USSD number!';
}

function check_ip(str)
{
	var rex=/^((2[0-4][0-9]|25[0-5]|[01]?[0-9][0-9]?)\.){3}(2[0-4][0-9]|25[0-5]|[01]?[0-9][0-9]?)$/i;
	if(rex.test(str)) {
		return false;
	}

	return 'Please input a valid IP address';
}

function check_mac(str)
{
	var rex=/^([0-9a-fA-F]{2}:){5}([0-9a-fA-F]){2}$/i;
	if(rex.test(str)) {
		return false;
	}

	return 'Please input a valid MAC address';
}

function check_pppoeuser(str)
{
	var rex=/^[\w@.`~!#$%^&*()+=\-\{\}\\\|:;\'"<>,.\?]{1,64}$/i;
	if(rex.test(str)) {
		return false;
	}

	return 'Please input valid username';
}

function check_pppoepwd(str)
{
	var rex=/^[\w@.`~!#$%^&*()+=\-\{\}\\\|:;\'"<>,.\?]{1,64}$/i;
	if(rex.test(str)) {
		return false;
	}

	return 'Please input valid password';
}

function con_str(str)
{
	return '<font color=ff0000>&nbsp;&nbsp;*'+str+'</font>';
}
